#ifndef __SAT_QUERIER__
#define __SAT_QUERIER__

#pragma once

#include "CritSection.h"
#include "SATProtocol.h"

namespace SATDEV{
	// 豸;
	enum DEVICE_TYPE{
		Virtual,
		Usb,
		Reticle
	};

	// 豸״̬;
	enum DEVICE_STATUS{
		Online,
		Offline,
		Dropline
	};

	// 豸ʹ״̬;
	enum DEVICE_USAGE_STATUS{
		Idle,
		InUse
	};

	// 豸Ϣ;
	typedef struct __DEVICE__ {
		int 			nType;			// 0=, 1=usb, 2=;
		std::string 	strName;		// 豸(IP:˿ں);
		// ʱָ̣ʱɾ豸,߳ʵʱˢʱ;
		ULONGLONG		ulOfflineTime;
		int				nStatus;		// 豸״̬0=,1=offline, 2=(drop line);
		int				nUsageState;	// 豸ʹ״̬0=,1=ʹ;
	}STDevice, *pSTDevice;

	// ׿豸adbӣUSBӡ;
	typedef struct __DEVICE_INFO__  {
		STDevice		dev;
		//////////////////////////////////////////////////////////////////////////
		// ;
		int				nStatus;		// 豸״̬0ʾ,1ʾæ;
		std::string		strSoftVersion;	// 汾;
		std::string		strModel;		// ģ;
		std::string		strHardVersion;	// Ӳ汾;
		std::string		strManu;		// ˵;		
	}STDeviceInfo, *pSTDeviceInfo;
}

class CSATDevices
{
	CSATDevices(void);
public:
	// ģʽ;
	static CSATDevices* GetInstance()
	{
		static CSATDevices* pInstance = NULL;
		if ( pInstance == NULL )
		{
			pInstance = new CSATDevices;
		}

		return pInstance;
	}

	~CSATDevices(void);

protected:
	// ߳̿ƾ;
	HANDLE  m_hEvent;
	// ߳̾;
	HANDLE	m_hWorkThread;

	// Ƿ׿豸;
	static bool s_bEnableAndroid;
	// ߲ʱ,λ;
	static ULONGLONG s_ulEraseDuration;	
	// ߳;
	static ThreadSection s_ThreadSection;
	// ׿豸б;
	static std::vector<SATDEV::STDevice> s_vtDevices;	

	// ӿ;
public:
	// ʼ;	
	void StartWork();
	// ;
	void EndofWork();
	// ߳;
	static DWORD WINAPI WorkThread(LPVOID lpVoid);

	const std::vector<SATDEV::STDevice>& GetDeviceList() const {return s_vtDevices;};
	// ɾ豸;
	static void DelDevices(std::string name);
	// 豸;
	static void AddReticleDevices(std::string ip);
	static void AddVirtualDevices(std::string name);
	// 豸Ƿ;
	static bool IsDeviceExist(SATDEV::STDevice &stDevice);
	// 豸Ƿ;
	static bool IsDevicesOffline(SATDEV::STDevice &stDevice, std::vector<SATDEV::STDevice> &vtDevices);
	// Ƿ豸;
	static bool IsNewDevices(SATDEV::STDevice &stDevice);
	// ȡǰ豸б;
	static void GetCurrentDevices(std::vector<SATDEV::STDevice> &vtDevices);
	// 豸;
	static void ReConnectAllDevices();
	// 豸ʹ״̬;
	static void SetDeviceUsageStatus(std::string strDevName, SATDEV::DEVICE_USAGE_STATUS status);

	// 豸;
	static int AttachDeviceName2Buffer(SATPROTO::Device (&pbuff)[30]);

};

#endif // __SAT_QUERIER__