#include "StdAfx.h"
#include "SATExecutor.h"
#include "ScriptExecutor.h"
#include "CharEncoding.h"

CSATExecutor::CSATExecutor(void)
{
	m_bLogin = FALSE;
	m_hEventHearbeat = NULL;
	m_hThreadHearbeat = NULL;
	m_hEventExcuteScript = NULL;
	m_hThreadExcuteScript = NULL;
}

CSATExecutor::~CSATExecutor(void)
{
}

bool CSATExecutor::IsTaskExist(SATHTTP::STTask &task)
{
	bool found = false;
	std::list<SATHTTP::STTask>::iterator it = m_vtTask.begin();
	for ( ; it != m_vtTask.end(); it++ ) {
		// ҪʹnTaskId,ֵûɶ;
		if ( it->Id == task.Id ) {
			found = true;
			break;
		}
	}

	return found;
}

SATHTTP::STTask* CSATExecutor::IsThereATaskInProcess()
{
	std::list<SATHTTP::STTask>::iterator it = m_vtTask.begin();
	for ( ; it != m_vtTask.end(); it++ ) {
		if ( it->_nExecutionState == 1 ) {
			return &(*it);
		}
	}

	return NULL;
}

SATHTTP::STTask* CSATExecutor::GetFreeTask()
{
	std::list<SATHTTP::STTask>::iterator it = m_vtTask.begin();
	for ( ; it != m_vtTask.end(); it++ ) {
		if ( it->_nExecutionState == 0 ) {
			return &(*it);
		}
	}

	return NULL;
}

void CSATExecutor::DelFinishedTask()
{
	AutoThreadSection ats(&m_csTask);
	std::list<SATHTTP::STTask>::iterator it = m_vtTask.begin();
	for ( ; it != m_vtTask.end(); it++ ) {
		// ״̬Ϊ2;
		if ( it->_nExecutionState == 2 ) {
			// ɾִ;
			for (std::vector<SATHTTP::STCase>::iterator _case = it->Job.vtCases.begin(); _case != it->Job.vtCases.end(); _case++ ) {
				if ( _case->_pExcutor )
					delete _case->_pExcutor;
				_case->_pExcutor = NULL;
			}
			m_vtTask.erase(it);
			break;
		}
	}
}

SATHTTP::STCase* CSATExecutor::IsCaseScriptProcess(std::vector<SATHTTP::STCase> &vtCases)
{
	std::vector<SATHTTP::STCase>::iterator it = vtCases.begin();
	for ( ; it != vtCases.end(); it++) {
		if ( it->_nExecutionState == 1 ) {
			return &(*it);
		}
	}

	return NULL;
}

SATHTTP::STCase* CSATExecutor::GetFreeCaseScript(std::vector<SATHTTP::STCase> &vtCases)
{
	std::vector<SATHTTP::STCase>::iterator it = vtCases.begin();
	for ( ; it != vtCases.end(); it++) {
		if ( it->_nExecutionState == 0 ) {
			return &(*it);
		}
	}

	return NULL;
}

SATHTTP::STCase* CSATExecutor::ExecuteFreeCaseScript(SATHTTP::STTask* pTask)
{
	SATHTTP::STCase* pCase = GetFreeCaseScript(pTask->Job.vtCases);
	if (pCase) {		
		if ( !pCase->_pExcutor ) {
			CScriptExecutor *pExcutor = new CScriptExecutor(); 
			if ( pExcutor ) {
				pCase->_pExcutor = pExcutor;
				// ־ļ·;
				pCase->_strCaseLog = pCase->_strFileDir + "\\" + pCase->_strFileName + ".txt";
				if ( pExcutor->InitScript(pCase->_strScriptPath, pCase->_strCaseLog, "", SUBPROCESS) ) {
					// ;
					pExcutor->SetCaseObje(pCase);
					pExcutor->StartScript();
					// ִ;
					pCase->_nExecutionState = 1;
				}
				else { // ʼʧ;
					pCase->_nExecutionState = 4;
				}

				// Ϊִ;
				pTask->_nExecutionState = 1;
				// ¼ʼʱ;
				pCase->_ulStartTickCount = GetTickCount64();
				pCase->_strStartTime = CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));
			}	
		}
		else {
			//CScriptExecutor *pExcutor = (CScriptExecutor *)pCase->_pExcutor;
		}
	}

	return pCase;
}

void CSATExecutor::AddDevices(const SATDEV::STDevice &stDevice)
{
	if ( IsDeviceExist(stDevice.strName) )
		return;

	SATHTTP::STDevice http_dev;
	// 豸ʹ״̬;
	if ( stDevice.nStatus == SATDEV::Idle )
		http_dev.strStatus = "0";
	else if ( stDevice.nStatus == SATDEV::InUse )
		http_dev.strStatus = "1";
	// 豸к;
	http_dev.strDeviceSerial = stDevice.strName;
	// ±̶ֵ;
	http_dev.strComments = "";
	http_dev.strCPU = "";
	http_dev.strDeviceMac = "";
	http_dev.strElectric = "";
	http_dev.strHardwareVersion = "SAT-HV";
	http_dev.strLastJob = "";
	http_dev.strLastJobFinishTime = "";
	http_dev.strLastJobStartTime = "";
	http_dev.strLastTimeBreak = "";
	http_dev.strLastTimeConnected = "";
	http_dev.strManu = "";
	http_dev.strMemory = "";
	http_dev.strModel = "SATModel";
	http_dev.strPhoneNumber = "";
	http_dev.strSoftwareVersion = "0123456789";

	m_vtDevice.push_back(http_dev);
}

void CSATExecutor::DelDevices(const SATDEV::STDevice &stDevice)
{
	std::vector<SATHTTP::STDevice>::iterator it = m_vtDevice.begin();
	for ( ; it != m_vtDevice.end(); it++ ) {
		if ( _tcsicmp(it->strDeviceSerial.c_str(), stDevice.strName.c_str()) == 0 ) {
			m_vtDevice.erase(it);
			break;
		}
	}
}

void CSATExecutor::SynchDeviceStatus(std::string strDevName, SATDEV::DEVICE_USAGE_STATUS status)
{
	std::vector<SATHTTP::STDevice>::iterator it = m_vtDevice.begin();
	for ( ; it != m_vtDevice.end(); it++ ) {
		if ( _tcsicmp(it->strDeviceSerial.c_str(), strDevName.c_str()) == 0 ) {
			if ( status == SATDEV::Idle )
				it->strStatus = "0";
			else if ( status == SATDEV::InUse )
				it->strStatus = "1";
			break;
		}
	}

	CSATDevices::SetDeviceUsageStatus(strDevName, status);
}

bool CSATExecutor::IsDeviceExist(std::string strDevName)
{
	bool bExist = false;
	std::vector<SATHTTP::STDevice>::iterator it = m_vtDevice.begin();
	for ( ; it != m_vtDevice.end(); it++ ) {
		if ( _tcsicmp(it->strDeviceSerial.c_str(), strDevName.c_str()) == 0 ) {
			bExist = true;
			break;
		}
	}

	return bExist;
}

bool CSATExecutor::Login(std::string user, std::string password, std::string actuator, bool bLogin /*= true*/)
{
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!executeLogin.action");
	// ;
	m_stLoginReq.strUserName = user;
	m_stLoginReq.strPassword = password;
	m_stLoginReq.strStatus = bLogin ? "0" : "1";   // 0ʾ¼;
	m_stLoginReq.strDeleteStatus = "";
	m_stLoginReq.strIP = GLOBAL::g_strIPAddress;
	m_stLoginReq.strStorage = "";
	if ( bLogin ) {
		m_stLoginReq.strDisconnectTime = "";
		m_stLoginReq.strConnectTime = CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));		
	} else { 
		m_stLoginReq.strConnectTime = "";
		m_stLoginReq.strDisconnectTime = CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));
	}
	// ִ;
	m_stLoginReq.strExecuteName = m_strActuatorName = actuator;
	// ִPCַ;
	m_stLoginReq.strMAC = GLOBAL::g_strMacs;	
	m_stLoginReq.strCPU = "";

	if ( ::Login(url, m_stLoginReq, m_stLoginResp) ) {
#ifdef _DEBUG
	OutputDebugString("¼ɹ\n");
#endif
		GLOBAL::WriteTextLog("¼ɹ");
		m_bLogin = TRUE;
		return true;
	}

#ifdef _DEBUG
	OutputDebugString("¼ʧ\n");
#endif
	GLOBAL::WriteTextLog("¼ʧ");

	return false;
}

bool CSATExecutor::Logout(std::string user, std::string password)
{
	return Login(user, password, false);
}

bool CSATExecutor::UpdateDevice()
{
	SATHTTP::STUpdateDeviceReq stUpdateDeviceReq;
	SATHTTP::STUpdateDeviceResp stUpdateDeviceResp;
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!updateDeviceMessage.action");
	// ״ֵ̬Ҫô?// ˴ͳһΪ0;
	stUpdateDeviceReq.strStatus = "0";
	stUpdateDeviceReq.strUserName = m_stLoginReq.strUserName;		
	stUpdateDeviceReq.strIP = GLOBAL::g_strIPAddress;
	stUpdateDeviceReq.strStorage = "";
	stUpdateDeviceReq.strRunnerName = m_strActuatorName;
	// ʹPCַ;
	stUpdateDeviceReq.strMAC = GLOBAL::g_strMacs;
	// reportType岻;
	stUpdateDeviceReq.strReportType = "1";
	stUpdateDeviceReq.strStartTime = CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));
	stUpdateDeviceReq.strMemory = "";
	stUpdateDeviceReq.strEndTime = "";
	stUpdateDeviceReq.strCPU = "";
	stUpdateDeviceReq.devicelist.assign(m_vtDevice.begin(), m_vtDevice.end());
	if ( !::UpdateDeviceMessage(url, stUpdateDeviceReq, stUpdateDeviceResp) )
	{
		return false;
	}
	
	return true;
}

bool CSATExecutor::NotifyTaskStart(SATHTTP::STTask* pTask)
{
	if ( !pTask )
		return false;

	SATHTTP::STNotifyJobStartReq stNotifyJobStartReq;
	SATHTTP::STNotifyJobStartResp stNotifyJobStartResp;
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResult.action");

	TCHAR szValue[36] = {0};
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stNotifyJobStartReq.strDeviceId = szValue;

	_itoa_s(pTask->nExecuteId, szValue, 10);
	stNotifyJobStartReq.strExecuteId = szValue;

	// _itoa_s(stTask.nInstanceId, szValue, 10); // 󵼣ӦʹidnInstanceId
	_itoa_s(pTask->Id, szValue, 10);
	stNotifyJobStartReq.strInstanceId = szValue;					

	//_itoa_s(pTask->nTaskId, szValue, 10);
	stNotifyJobStartReq.strTaskId = pTask->Job.strTaskId;

	// ӳ·к?
	stNotifyJobStartReq.strSignalImageUrl = GLOBAL::g_stSATConfig.szScriptDir;
	stNotifyJobStartReq.strSignalImageUrl.append(pTask->strTaskName+"\\\\");
	stNotifyJobStartReq.strSignalImageUrl.append(pTask->Job.strUniqueId+"\\\\");
	stNotifyJobStartReq.strSignalImageUrl.append(pTask->Job.strDeviceId);

	if ( SetResult(url, stNotifyJobStartReq, stNotifyJobStartResp) )
	{
		// ˴Ҫ豸Ϊæµ״̬;
		// SetDeviceStatus(BUSY);
		return true;
	}

#ifdef _DEBUG
	OutputDebugString("֪ͨSATʧ\n");
#endif

	return false;
}

bool CSATExecutor::UploadCaseImg(SATHTTP::STTask* pTask, SATHTTP::STCase *pCase, std::string img)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!saveResultImg.action");

	SATHTTP::STSaveImgReq stSaveImgReq;
	SATHTTP::STSaveImgResp stSaveImgResp;

	stSaveImgReq.strCaseId = pCase->strId;
	stSaveImgReq.strCaseRepeat = "0";
	_itoa_s(pCase->_nCaseStep, szValue, 10);
	stSaveImgReq.strCaseStep = szValue;
	// ʵId;
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stSaveImgReq.strDeviceId = szValue;//pTask->Job.strDeviceId;
	// TaskеExecuteId
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stSaveImgReq.strExecuteId = szValue;
	// ʵId;
	_itoa_s(pTask->nInstanceId, szValue, 10);
	stSaveImgReq.strInstanceId = szValue;
	stSaveImgReq.strJobRepeat = "0";
	// עܿӣroundnum븳ֵ01;
	stSaveImgReq.strRoundNum = "0";
	stSaveImgReq.strTaskType = pTask->strTaskType;
	stSaveImgReq.strUploads = img;

	// ϴͼƬ;
	if ( SaveResultImg(url, stSaveImgReq, stSaveImgResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::UploadCaseLog(SATHTTP::STTask* pTask, SATHTTP::STCase *pCase)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!saveCaseOrTaskLog.action");

	SATHTTP::STSaveLogReq stSaveLogReq;
	SATHTTP::STSaveLogResp stSaveLogResp;

	stSaveLogReq.strCaseId = pCase->strId;
	// ִID;
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stSaveLogReq.strExecuteId = szValue;
	stSaveLogReq.strFileType = "caseLogFile";
	// Id;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stSaveLogReq.strTaskId = pTask->Job.strTaskInstanceId;
	stSaveLogReq.strUserId = pTask->Job.strUserId;
	// Ҫϴ־ļ;
	stSaveLogReq.strUploads = pCase->_strCaseLog;
	if ( SaveCaseOrTaskLog(url, stSaveLogReq, stSaveLogResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::ReportCaseItemFinish(SATHTTP::STTask* pTask, SATHTTP::STCase *pCase, STCaseItem &caseItem)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResultList.action");

	SATHTTP::STJobProcessReq stJobProcessReq;
	SATHTTP::STJobProcessResp stJobProcessResp;

	stJobProcessReq.strResultState = caseItem.result ? "1" : "0";
	stJobProcessReq.strCaseScene = "";
	// ;
	_itoa_s(pCase->_nCaseStep, szValue, 10);
	stJobProcessReq.strCaseStep = szValue;
	stJobProcessReq.strApkMD5 = "";
	stJobProcessReq.strCrashTime = "";
	// TaskеExecuteId
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stJobProcessReq.strRunnerId = szValue;
	stJobProcessReq.strCPUInfo = "0";
	stJobProcessReq.strRunnedActionNameList = "";
	stJobProcessReq.strArtificialResult = "";
	stJobProcessReq.strArtificialModify = "";
	stJobProcessReq.strRunnerName = "";
	stJobProcessReq.strTaskType = "FUNCTIONALITY";
	stJobProcessReq.strCaseRepeat = "0";
	stJobProcessReq.strApplicationGroup = "";
	// ʵId;
	_itoa_s(pTask->Id, szValue, 10);
	stJobProcessReq.strInstanceId = szValue;
	stJobProcessReq.strCaseId = pCase->strId;
	// ;
	_itoa_s(100*(atoi(pCase->strIndex.c_str()))/pTask->Job.vtCases.size(), szValue, 10);
	stJobProcessReq.strProgress = szValue;
	// Ҫutf-8תgbk;
	stJobProcessReq.strReusltMessage = caseItem.name;//CharEncoding::UTF82ASCII(caseItem.name.c_str());
	stJobProcessReq.strJobRepeat = "0";
	stJobProcessReq.strScreenShot = "";
	stJobProcessReq.strStartTime = pCase->_strStartTime;
	stJobProcessReq.strCrashNumber = "";
	stJobProcessReq.strCaseName = pCase->strCaseName;
	//stJobProcessReq.strFailedReason = CharEncoding::UTF82ASCII(caseItem.remark.c_str());
	//stJobProcessReq.strFailedReason = (char*)CharEncoding::UTF82UNICODE(caseItem.remark.c_str());
	stJobProcessReq.strFailedReason = caseItem.remark;
	for (std::vector<std::string>::iterator it = caseItem.imgs.begin(); it != caseItem.imgs.end(); it++ )
	{
		int npos = it->find_last_of('/');
		if ( std::string::npos != npos )
		{
			stJobProcessReq.strImgName.append(it->substr(npos+1));
			stJobProcessReq.strImgName.append("&");
		}
	}
	if ( stJobProcessReq.strImgName.size() && stJobProcessReq.strImgName.at(stJobProcessReq.strImgName.size()-1) == '&')
		stJobProcessReq.strImgName.erase(stJobProcessReq.strImgName.size()-1);
	stJobProcessReq.strCaseIndex = pCase->strIndex;
	// ʵId;
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stJobProcessReq.strDeviceId = szValue;
	stJobProcessReq.strSceneIndex = "0";
	// ʵId;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stJobProcessReq.strTaskId = pTask->Job.strTaskId;
	//stJobProcessReq.strAnalysis = CharEncoding::UTF82ASCII(caseItem.data.c_str());
	stJobProcessReq.strAnalysis = caseItem.data.c_str(); 
	// 豸ƣDeviceSerial;
	stJobProcessReq.strDevnceName = pTask->Job.strDeviceId;	// 䲻Χ,һdeviceiddeviceserial,һid;
	// ̶ΪTOTAL
	stJobProcessReq.strInfoType = "";
	// Android豸,Ҫͨadbȡ;
	//stJobProcessReq.strMemoryInfo = stDevice.strMemory;
	stJobProcessReq.strEndTime = CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));//"2019-12-16 10:18:20";
	stJobProcessReq.strRoundNumber = "1";
	stJobProcessReq.strResultType = "4";		// reportActionFinish;
	stJobProcessReq.strOperationStep = "";

	if ( SetResultList(url, stJobProcessReq, stJobProcessResp) )
	{
		// ϴͼƬ;
		std::string img;
		for (std::vector<std::string>::iterator it = caseItem.imgs.begin(); it != caseItem.imgs.end(); it++ )
		{
			img = "D:/SAT/results/";
			img.append(it->substr(3));
			UploadCaseImg(pTask, pCase, img);
		}

		return true;
	}

	return false;
}

bool CSATExecutor::ReportCaseFinish(SATHTTP::STTask* pTask, SATHTTP::STCase *pCase)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResultList.action");

	SATHTTP::STJobProcessReq stJobProcessReq;
	SATHTTP::STJobProcessResp stJobProcessResp;

	// ϱ0ʾűɹִ,	1ʾűʱ;
	if ( pCase->_nExecutionState == 2 )
		stJobProcessReq.strResultState = "0";	// űδִ;
	else if ( pCase->_nExecutionState == 1 )	
		stJobProcessReq.strResultState = "1";	// űִ,Ϊfail;
	
	stJobProcessReq.strCaseScene = "";
	// ;
	_itoa_s(pCase->_nCaseStep, szValue, 10);
	stJobProcessReq.strCaseStep = szValue;
	stJobProcessReq.strApkMD5 = "";
	stJobProcessReq.strCrashTime = "";
	// TaskеExecuteId
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stJobProcessReq.strRunnerId = szValue;
	stJobProcessReq.strCPUInfo = "0";
	stJobProcessReq.strRunnedActionNameList = "";
	stJobProcessReq.strArtificialResult = "";
	stJobProcessReq.strArtificialModify = "";
	stJobProcessReq.strRunnerName = "";
	stJobProcessReq.strTaskType = "FUNCTIONALITY";
	stJobProcessReq.strCaseRepeat = "";
	stJobProcessReq.strApplicationGroup = "";
	// ʵId;עܿ;
	_itoa_s(pTask->Id, szValue, 10);
	stJobProcessReq.strInstanceId = szValue;
	stJobProcessReq.strCaseId = pCase->strId;
	// (###Ҫ޸Ĵ˴###);
	_itoa_s(100*(atoi(pCase->strIndex.c_str()))/pTask->Job.vtCases.size(), szValue, 10);
	stJobProcessReq.strProgress = szValue;
	// Ҫutf-8תgbk;
	stJobProcessReq.strReusltMessage = CharEncoding::ASCII2UTF8("");
	stJobProcessReq.strJobRepeat = "";
	stJobProcessReq.strScreenShot = "";
	stJobProcessReq.strStartTime = pCase->_strStartTime;
	stJobProcessReq.strCrashNumber = "";
	stJobProcessReq.strCaseName = pCase->strCaseName;
	stJobProcessReq.strFailedReason = "";

	stJobProcessReq.strImgName = "";
	stJobProcessReq.strCaseIndex = pCase->strIndex;
	// ʵId;
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stJobProcessReq.strDeviceId = szValue;
	stJobProcessReq.strSceneIndex = "0";
	// ʵId;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stJobProcessReq.strTaskId = pTask->Job.strTaskId;
	stJobProcessReq.strAnalysis = "";
	// 豸ƣDeviceSerial;
	stJobProcessReq.strDevnceName = pTask->Job.strDeviceId;	// 䲻Χ,һdeviceiddeviceserial,һid;
	// ̶ΪTOTAL
	stJobProcessReq.strInfoType = "TOTAL";
	// Android豸,Ҫͨadbȡ;
	//stJobProcessReq.strMemoryInfo = stDevice.strMemory;
	stJobProcessReq.strEndTime = pCase->_strEndTime;//CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));//"2019-12-16 10:18:20";
	stJobProcessReq.strRoundNumber = "1";
	stJobProcessReq.strResultType = "5";		// reportCaseFinish;
	stJobProcessReq.strOperationStep = "";

	if ( SetResultList(url, stJobProcessReq, stJobProcessResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::ReportCaseResult(SATHTTP::STTask* pTask, SATHTTP::STCase *pCase)
{
	// ȡxmlļ;
	std::string xmlpath = "D:\\SAT\\results\\detail\\";
	xmlpath.append(pCase->_strFileName);
	xmlpath.append("_result.xml");
	std::vector<STCaseItem> vtCaseItem;
	GetCaseXMLResult(xmlpath, vtCaseItem);
	//if ( vtCaseItem.size() == 0 )
	//	return false;
	
	int nIndex = 1;
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResultList.action");
	SATHTTP::STJobProcessReq stJobProcessReq;
	SATHTTP::STJobProcessResp stJobProcessResp;
	// ;
	std::vector<STCaseItem>::iterator it = vtCaseItem.begin();
	for (; it != vtCaseItem.end(); it++ )
	{
		// ϱ(Ƭ);
		ReportCaseItemFinish(pTask, pCase, *it);		
	}

	// ϱ;
	ReportCaseFinish(pTask, pCase);

	// ϴ־;
	UploadCaseLog(pTask, pCase);

	// ɾִж;
	if ( pCase->_pExcutor )
		delete pCase->_pExcutor;
	pCase->_pExcutor = NULL;
	GLOBAL::WriteTextLog(_T("ִɾɹűΪ=%s"), pCase->strCaseName.c_str());

	return true;
}

bool CSATExecutor::UploadTaskLog(SATHTTP::STTask* pTask)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!saveCaseOrTaskLog.action");

	SATHTTP::STSaveLogReq stSaveLogReq;
	SATHTTP::STSaveLogResp stSaveLogResp;

	stSaveLogReq.strCaseId = "";
	// ִID;
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stSaveLogReq.strExecuteId = szValue;
	stSaveLogReq.strFileType = "taskLogFile";
	// Id;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stSaveLogReq.strTaskId = pTask->Job.strTaskInstanceId;
	stSaveLogReq.strUserId = pTask->Job.strUserId;
	// Ҫϴ־ļ;
	stSaveLogReq.strUploads = "D:\\sat\\log.txt";//pTask->_strTaskLog;
	if ( SaveCaseOrTaskLog(url, stSaveLogReq, stSaveLogResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::ReportTaskStart(SATHTTP::STTask* pTask)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResultList.action");

	SATHTTP::STJobProcessReq stJobProcessReq;
	SATHTTP::STJobProcessResp stJobProcessResp;

	// Ҫ###
	stJobProcessReq.strResultState = "";	// űִ,Ϊfail;

	stJobProcessReq.strCaseScene = "";
	// ;
	stJobProcessReq.strCaseStep = "0";
	stJobProcessReq.strApkMD5 = "";
	stJobProcessReq.strCrashTime = "";
	// TaskеExecuteId
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stJobProcessReq.strRunnerId = szValue;
	stJobProcessReq.strCPUInfo = "0";
	stJobProcessReq.strRunnedActionNameList = "";
	stJobProcessReq.strArtificialResult = "";
	stJobProcessReq.strArtificialModify = "";
	stJobProcessReq.strRunnerName = "";
	stJobProcessReq.strTaskType = "FUNCTIONALITY";
	stJobProcessReq.strCaseRepeat = "";
	stJobProcessReq.strApplicationGroup = "";
	// ʵId;עܿ;
	_itoa_s(pTask->Id, szValue, 10);
	stJobProcessReq.strInstanceId = szValue;
	stJobProcessReq.strCaseId = "";
	// (###Ҫ޸Ĵ˴###);
	stJobProcessReq.strProgress = "0";
	// Ҫutf-8תgbk;
	stJobProcessReq.strReusltMessage = "ʼ";
	stJobProcessReq.strJobRepeat = "";
	stJobProcessReq.strScreenShot = "";
	stJobProcessReq.strStartTime = pTask->strStartTime;
	stJobProcessReq.strCrashNumber = "";
	stJobProcessReq.strCaseName = "";
	stJobProcessReq.strFailedReason = "";

	stJobProcessReq.strImgName = "";
	stJobProcessReq.strCaseIndex = "";
	// ʵId;
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stJobProcessReq.strDeviceId = szValue;
	stJobProcessReq.strSceneIndex = "";
	// ʵId;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stJobProcessReq.strTaskId = pTask->Job.strTaskId;
	stJobProcessReq.strAnalysis = "";
	// 豸ƣDeviceSerial;
	stJobProcessReq.strDevnceName = pTask->Job.strDeviceId;	// 䲻Χ,һdeviceiddeviceserial,һid;
	// ̶ΪTOTAL
	stJobProcessReq.strInfoType = "TOTAL";
	// Android豸,Ҫͨadbȡ;
	//stJobProcessReq.strMemoryInfo = stDevice.strMemory;
	stJobProcessReq.strEndTime = "";// CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));//"2019-12-16 10:18:20";
	stJobProcessReq.strRoundNumber = "1";
	stJobProcessReq.strResultType = "0";		// reportJobStart;
	stJobProcessReq.strOperationStep = "";

	if ( SetResultList(url, stJobProcessReq, stJobProcessResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::ReportTaskFinish(SATHTTP::STTask* pTask)
{
	TCHAR szValue[MAX_PATH] = {0};
	std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
	url.append("/ajaxInteractiveManage!setResultList.action");

	SATHTTP::STJobProcessReq stJobProcessReq;
	SATHTTP::STJobProcessResp stJobProcessResp;

	// Ҫ###
	stJobProcessReq.strResultState = "0";	// űִ,Ϊfail;

	stJobProcessReq.strCaseScene = "";
	// ;
	stJobProcessReq.strCaseStep = "0";
	stJobProcessReq.strApkMD5 = "";
	stJobProcessReq.strCrashTime = "";
	// TaskеExecuteId
	_itoa_s(pTask->nExecuteId, szValue, 10);
	stJobProcessReq.strRunnerId = szValue;
	stJobProcessReq.strCPUInfo = "0";
	stJobProcessReq.strRunnedActionNameList = "";
	stJobProcessReq.strArtificialResult = "";
	stJobProcessReq.strArtificialModify = "";
	stJobProcessReq.strRunnerName = "";
	stJobProcessReq.strTaskType = "FUNCTIONALITY";
	stJobProcessReq.strCaseRepeat = "0";
	stJobProcessReq.strApplicationGroup = "";
	// ʵId;עܿ;
	_itoa_s(pTask->Id, szValue, 10);
	stJobProcessReq.strInstanceId = szValue;
	stJobProcessReq.strCaseId = "";
	// (###Ҫ޸Ĵ˴###);
	stJobProcessReq.strProgress = "100";
	// Ҫutf-8תgbk;
	stJobProcessReq.strReusltMessage = "";
	stJobProcessReq.strJobRepeat = "0";
	stJobProcessReq.strScreenShot = "";
	stJobProcessReq.strStartTime = pTask->strStartTime;
	stJobProcessReq.strCrashNumber = "";
	stJobProcessReq.strCaseName = "";
	stJobProcessReq.strFailedReason = "";

	stJobProcessReq.strImgName = "";
	stJobProcessReq.strCaseIndex = "";
	// ʵId;
	_itoa_s(pTask->nDeviceId, szValue, 10);
	stJobProcessReq.strDeviceId = szValue;
	stJobProcessReq.strSceneIndex = "0";
	// ʵId;
	//_itoa_s(pTask->nTaskId, szValue, 10);
	stJobProcessReq.strTaskId = pTask->Job.strTaskId;
	stJobProcessReq.strAnalysis = "";
	// 豸ƣDeviceSerial;
	stJobProcessReq.strDevnceName = pTask->Job.strDeviceId;	// 䲻Χ,һdeviceiddeviceserial,һid;
	// ̶ΪTOTAL
	stJobProcessReq.strInfoType = "";
	// Android豸,Ҫͨadbȡ;
	//stJobProcessReq.strMemoryInfo = stDevice.strMemory;
	stJobProcessReq.strEndTime = CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S"));//"2019-12-16 10:18:20";
	stJobProcessReq.strRoundNumber = "1";
	stJobProcessReq.strResultType = "1";		// reportJobFinish;
	stJobProcessReq.strOperationStep = "";

	if ( SetResultList(url, stJobProcessReq, stJobProcessResp) )
	{
		return true;
	}

	return false;
}

bool CSATExecutor::GetCaseXMLResult(std::string xmlpath, std::vector<STCaseItem> &vtCaseItem)
{
	// xml;
	tinyxml2::XMLDocument doc;
	if (tinyxml2::XML_SUCCESS != doc.LoadFile(xmlpath.c_str()) ) {
		return false;
	}

	tinyxml2::XMLElement *pXmlRoot = NULL;
	if ((pXmlRoot = doc.RootElement()) == NULL)
		return false;
	
	if (_tcsicmp(pXmlRoot->Value(), "results") != 0)
		return false;
	
	tinyxml2::XMLElement *pXmlElent = pXmlRoot->FirstChildElement();
	while (pXmlElent) {
		if (_tcsicmp(pXmlElent->Value(), _T("item")) == 0) {
			STCaseItem cItem;
			tinyxml2::XMLElement *pItem = pXmlElent->FirstChildElement();
			while (pItem) {
				if (_tcsicmp(pItem->Value(), _T("name")) == 0)
				{
					cItem.name = pItem->GetText();
				}
				else if (_tcsicmp(pItem->Value(), _T("result")) == 0)
				{
					cItem.result = pItem->BoolText();
				}
				else if (_tcsicmp(pItem->Value(), _T("data")) == 0)
				{
					cItem.data = pItem->GetText();
				}
				else if (_tcsicmp(pItem->Value(), _T("log")) == 0)
				{
					cItem.log = pItem->GetText();
				}
				else if (_tcsicmp(pItem->Value(), _T("remark")) == 0)
				{
					cItem.remark = pItem->GetText();
				}
				else if (_tcsicmp(pItem->Value(), _T("screen")) == 0)
				{
					cItem.imgs.push_back(pItem->GetText());
				}

				pItem = pItem->NextSiblingElement();
			}

			// ѹ;
			if ( cItem.name.size() )
				vtCaseItem.push_back(cItem);
		}

		pXmlElent = pXmlElent->NextSiblingElement();
	}
	
	return true;
}

void CSATExecutor::StartWork()
{
	m_hEventHearbeat = CreateEvent(NULL, TRUE, FALSE, NULL);
	if ( m_hEventHearbeat == NULL ) {
		_tprintf_s(_T("¼ʧ\n"));
		return;
	}

	m_hEventExcuteScript = CreateEvent(NULL, TRUE, FALSE, NULL);
	if ( m_hEventExcuteScript == NULL ) {
		_tprintf_s(_T("¼ʧ2\n"));
		return;
	}

	m_hThreadHearbeat = CreateThread(NULL, 0, HearbeatThread, this, 0, NULL);
	if ( m_hThreadHearbeat == NULL) {
		SetEvent(m_hEventHearbeat);
		SetEvent(m_hEventExcuteScript);
		CloseHandle(m_hEventHearbeat);
		CloseHandle(m_hEventExcuteScript);
		m_hEventHearbeat = NULL;
		m_hEventExcuteScript = NULL;
		_tprintf_s(_T("߳ʧ\n"));
		return;
	}

	m_hThreadExcuteScript = CreateThread(NULL, 0, ExecuteScriptThread, this, 0, NULL);
	if ( m_hThreadExcuteScript == NULL ) {
		SetEvent(m_hEventHearbeat);
		SetEvent(m_hEventExcuteScript);
		CloseHandle(m_hEventHearbeat);
		CloseHandle(m_hEventExcuteScript);
		m_hEventHearbeat = NULL;
		m_hEventExcuteScript = NULL;
		WaitForSingleObject(m_hThreadHearbeat,INFINITE);
		if (m_hThreadHearbeat)
			CloseHandle(m_hThreadHearbeat);
		m_hThreadHearbeat = NULL;
		_tprintf_s(_T("߳ʧ2\n"));
		return;
	}
}

void CSATExecutor::EndofWork()
{
	//////////////////////////////////////////////////////////////////////////
	// ¼ź;
	if ( m_hEventHearbeat )
		SetEvent(m_hEventHearbeat);

	// ȴ߳̽;
	if ( m_hThreadHearbeat ) {
		WaitForSingleObject(m_hThreadHearbeat, INFINITE);
		CloseHandle(m_hThreadHearbeat);
		m_hThreadHearbeat = NULL;
	}

	// ر¼;
	if ( m_hEventHearbeat ) {
		CloseHandle(m_hEventHearbeat);
		m_hEventHearbeat = NULL;
	}

	//////////////////////////////////////////////////////////////////////////
	// ¼ź;
	if ( m_hEventExcuteScript )
		SetEvent(m_hEventExcuteScript);

	// ȴ߳̽;
	if ( m_hThreadExcuteScript ) {
		WaitForSingleObject(m_hThreadExcuteScript, INFINITE);
		CloseHandle(m_hThreadExcuteScript);
		m_hThreadExcuteScript = NULL;
	}

	// ر¼;
	if ( m_hEventExcuteScript ) {
		CloseHandle(m_hEventExcuteScript);
		m_hEventExcuteScript = NULL;
	}
}

DWORD CSATExecutor::HearbeatThread(LPVOID lpVoid)
{
	CSATExecutor *that = (CSATExecutor*)lpVoid;
	if ( !that ) return 0;
	
	do {
		// ûе¼ɹ,ѯ;
		if ( !that->m_bLogin ) continue;
		// 豸;
		that->UpdateDevice();
		// űĿ¼;
		std::string strScriptSaveDir;
		SATHTTP::STHeartbeatReq stHeartbeatReq;
		SATHTTP::STHeartbeatResp stHeartbeatResp;
		std::string url = GLOBAL::g_stSATConfig.szExecuteServer;
		url.append("/ajaxInteractiveManage!executeHeartbeat.action");

		stHeartbeatReq.strUserName = that->m_stLoginReq.strUserName;
		stHeartbeatReq.strRunnerMac = that->m_stLoginReq.strMAC;
		stHeartbeatReq.devicelist.assign(that->m_vtDevice.begin(), that->m_vtDevice.end());
		if ( Heartbeat(url, stHeartbeatReq, stHeartbeatResp) ) {
			std::vector<SATHTTP::STTask>::iterator it = stHeartbeatResp.vtTask.begin();
			for ( ; it != stHeartbeatResp.vtTask.end(); it++ ) {
				if (!that->IsTaskExist(*it)) {
					// ѹ;
					AutoThreadSection ats(&that->m_csTask);
					// ͬʱ;
					std::string host = GLOBAL::g_stSATConfig.szCaseServer;
					std::string url = host + "/ajaxInteractiveManage!getCaseFileListUrl.action";
					std::vector<SATHTTP::STCase>::iterator _case = it->Job.vtCases.begin();
					for ( int i = 1; _case != it->Job.vtCases.end(); _case++) {
						// ؽű;
						_case->_nCaseStep = i++;
						SATHTTP::STScriptUrlResp stScriptUrlResp;
						// ű·;
						strScriptSaveDir = GLOBAL::g_stSATConfig.szScriptDir;
						strScriptSaveDir.append(it->Job.strProjectName+"\\");
						strScriptSaveDir.append(it->Job.strUniqueId+"\\");
						// ðŸĳ»;
						strScriptSaveDir.append(GLOBAL::Replace(it->Job.strDeviceId, "_", ":")+"\\");
						if ( DownloadScript(url, _case->strId, strScriptSaveDir, stScriptUrlResp) ) {
							_case->_strFileDir = stScriptUrlResp._strFileDir;
							_case->_strFileName = stScriptUrlResp._strFileName;
							_case->_strScriptPath = stScriptUrlResp._strScripFile;
						}
					}

					that->m_vtTask.push_back(*it);

					// ֪ͨSAT,űʼִ;
					// ͬʱ洢ݿ;
					/*
					db process
					*/
				}
			}
		}

	} while ( WaitForSingleObject(that->m_hEventHearbeat, 5000) == WAIT_TIMEOUT );

	return 0;
}

DWORD CSATExecutor::ExecuteScriptThread(LPVOID lpVoid)
{
	CSATExecutor *that = (CSATExecutor*)lpVoid;
	if ( !that ) return 0;

	do {
		// ɾɵ;
		that->DelFinishedTask();
		// Ƿִ;
		SATHTTP::STTask *pTask = that->IsThereATaskInProcess();
		if ( pTask ) {// ִ;
			if ( pTask->_bConcurrent ) {// ;

			}
			else {// ;
				// Ƿнűִ;
				SATHTTP::STCase* pCase = that->IsCaseScriptProcess(pTask->Job.vtCases);
				if ( pCase ) {
					CScriptExecutor *pExcutor = (CScriptExecutor*)pCase->_pExcutor;
					if ( pExcutor ) {
						if ( pExcutor->IsScriptOver() ) {
							pCase->_nExecutionState = 2;
							// ϱ,ɽű,ϴ;
							that->ReportCaseResult(pTask, pCase);
						}
						else {
							// жǷʱ;
							ULONGLONG ulCurTickCount = GetTickCount64();
							if ( ulCurTickCount - pExcutor->GetActiveTickCount() > GLOBAL::g_stSATConfig.dwScriptTimeout ) {	
								// ;
								pExcutor->EndSubprocess();
								// ʱж;
								pCase->_nExecutionState = 3;
								// ϱ;
								that->ReportCaseResult(pTask, pCase);
							}
						}
					}
				}
				else {
					// ûִе,ʼִµ;
					pCase = that->ExecuteFreeCaseScript(pTask);
					if ( NULL == pCase ) {
						// ûпеִ,˵ִ;
						pTask->_nExecutionState = 2;
						// ϱ;
						that->ReportTaskFinish(pTask);
						// ϱ;
						that->UploadTaskLog(pTask);
					}
				}
			}
		}
		else {
			// ȡе;
			pTask = that->GetFreeTask();
			if ( pTask ) {
				// Ƿֲ֧;
				if ( pTask->_bConcurrent ) {
					// ʱȫһ𲢷;
					std::vector<SATHTTP::STCase>::iterator _case = pTask->Job.vtCases.begin();
					for ( ; _case != pTask->Job.vtCases.end(); _case++) {
						if (!_case->_pExcutor) {					
							CScriptExecutor *pExcutor = new CScriptExecutor();
							if ( pExcutor ) {
								_case->_pExcutor = pExcutor;
								pExcutor->InitScript(_case->_strScriptPath, _case->_strFileDir + "\\" + _case->_strFileName + ".txt", "", SUBPROCESS);
								pExcutor->StartScript();
								// ִ;
								_case->_nExecutionState = 1;
							}
						}
					}

					// Ϊִ;
					pTask->_nExecutionState = 1;
				}
				else {
					// Ƿűִ;
					SATHTTP::STCase* pCase = that->IsCaseScriptProcess(pTask->Job.vtCases);
					if ( !pCase ) {
						// ִпű;
						that->ExecuteFreeCaseScript(pTask);
					}				
				}

				// ֪ͨSAT,űʼִ;
				that->NotifyTaskStart(pTask);

				// ֪ͨSAT,űʼ;
				that->ReportTaskStart(pTask);
			}	
		}
	} while ( WaitForSingleObject(that->m_hEventExcuteScript, 10000) == WAIT_TIMEOUT );

	return 0;
}