#ifndef __SAT_EXECUTOR__
#define __SAT_EXECUTOR__

#pragma once

#include "CritSection.h"
#include "SATDevices.h"

// xml;
typedef struct __ST_CASEITEM__
{
	bool result;
	std::string name;
	std::string data;
	std::vector<std::string> imgs;
	std::string log;
	std::string remark;
}STCaseItem, *pSTCaseItem;

class CSATExecutor
{
	CSATExecutor(void);
public:
	// ģʽ;
	static CSATExecutor* GetInstance()
	{
		static CSATExecutor* pInstance = NULL;
		if ( pInstance == NULL )
		{
			pInstance = new CSATExecutor;
		}

		return pInstance;
	}

	~CSATExecutor(void);

protected:
	// ߳̿ƾ;
	HANDLE  m_hEventHearbeat;
	// ߳̾;
	HANDLE	m_hThreadHearbeat;
	// ߳̿ƾ;
	HANDLE  m_hEventExcuteScript;
	// ִ߳̾;
	HANDLE	m_hThreadExcuteScript;

	// Ƿ¼ɹ;
	BOOL	m_bLogin;

	ThreadSection	m_csTask;
	std::list<SATHTTP::STTask> m_vtTask;
	std::vector<SATHTTP::STDevice> m_vtDevice;
	SATHTTP::STLoginReq	m_stLoginReq;
	SATHTTP::STLoginResp	m_stLoginResp;
	// ִ;
	std::string m_strActuatorName;

	// Ƿ;
	bool IsTaskExist(SATHTTP::STTask &task);
	// Ƿִ;
	SATHTTP::STTask* IsThereATaskInProcess();
	// ȡδִе;
	SATHTTP::STTask* GetFreeTask();
	// Ƴɵ;
	void DelFinishedTask();
	// Ƿűִ;
	SATHTTP::STCase* IsCaseScriptProcess(std::vector<SATHTTP::STCase> &vtCases);
	// ȡδִе;
	SATHTTP::STCase* GetFreeCaseScript(std::vector<SATHTTP::STCase> &vtCases);
	// ִп;
	SATHTTP::STCase* ExecuteFreeCaseScript(SATHTTP::STTask* pTask);
	
public:
	// 豸;
	void AddDevices(const SATDEV::STDevice &stDevice);
	// ɾ豸;
	void DelDevices(const SATDEV::STDevice &stDevice);
	// ͬ豸״̬;
	void SynchDeviceStatus(std::string strDevName, SATDEV::DEVICE_USAGE_STATUS status);
	// 豸Ƿ;
	bool IsDeviceExist(std::string strDevName);

public:
	// ¼;
	bool Login(std::string user, std::string password, std::string actuator, bool bLogin = true);
	// ǳ;
	bool Logout(std::string user, std::string password);
	const SATHTTP::STLoginResp *GetLoginResp() const{ return &m_stLoginResp;};
	// ִ;
	void SetActuatorName(const char *pszActuator){ if (pszActuator) m_strActuatorName = pszActuator;};
	// 豸Ϣ;
	bool UpdateDevice();
	// ֪ͨSATʼ;
	bool NotifyTaskStart(SATHTTP::STTask* pTask);
	// ϴͼƬ;
	bool UploadCaseImg(SATHTTP::STTask* pTask, SATHTTP::STCase *pCase, std::string img);
	// ϴ;
	bool UploadCaseLog(SATHTTP::STTask* pTask, SATHTTP::STCase *pCase);
	// ϱ;
	bool ReportCaseItemFinish(SATHTTP::STTask* pTask, SATHTTP::STCase *pCase, STCaseItem &caseItem);
	// ϱ;
	bool ReportCaseFinish(SATHTTP::STTask* pTask, SATHTTP::STCase *pCase);
	// ϱ;
	bool ReportCaseResult(SATHTTP::STTask* pTask, SATHTTP::STCase *pCase);
	// ϴ;
	bool UploadTaskLog(SATHTTP::STTask* pTask);
	// ϱʼ;
	bool ReportTaskStart(SATHTTP::STTask* pTask);
	// ϱ;
	bool ReportTaskFinish(SATHTTP::STTask* pTask);
	// ȡxml;
	bool GetCaseXMLResult(std::string xmlpath, std::vector<STCaseItem> &vtCaseItem);
	// ӿ;
public:
	// ʼ;	
	void StartWork();
	// ;
	void EndofWork();

	// dbм;
	void LoadTaskInfo();
	// ߳;
	static DWORD WINAPI HearbeatThread(LPVOID lpVoid);
	// ִ߳;
	static DWORD WINAPI ExecuteScriptThread(LPVOID lpVoid);
};


#endif //__SAT_EXECUTOR__